import 'package:flutter_bloc/flutter_bloc.dart';

extension DebuggableBloc on BlocBase<dynamic> {
  static final _showInObserver = Expando<bool>();

  bool get showInObserver => _showInObserver[this] ?? true;

  set showInObserver(bool value) => _showInObserver[this] = value;

  /// Show the bloc in the observer
  void show() {
    showInObserver = true;
  }

  /// Hide the bloc from the observer
  void hide() {
    showInObserver = false;
  }
}
